#ifndef WAVE_H
#define WAVE_H

#include <stdint.h>


/* Maximum number of embedded waves */
#define MAX_WAVES		4

/* Length of embedded waves */
#define WAVEBYTECODE_PLAY_LENGTH 						10720
#define WAVEBYTECODE_TRAIN_LENGTH						10336
#define WAVEBYTECODE_CORRECT_LENGTH					11567
#define WAVEBYTECODE_WRONG_LENGTH						9236

/* Resolution of embedded waves (bits per sample) */
#define WAVEBYTECODE_PLAY_BPS 							8
#define WAVEBYTECODE_TRAIN_BPS							8
#define WAVEBYTECODE_CORRECT_BPS						8
#define WAVEBYTECODE_WRONG_BPS							8

/* Rate of embedded waves (sample per second) */
#define WAVEBYTECODE_PLAY_SPS 							22050
#define WAVEBYTECODE_TRAIN_SPS							22050
#define WAVEBYTECODE_CORRECT_SPS						22050
#define WAVEBYTECODE_WRONG_SPS							22050

/* Export embedded waves definition */
extern const uint8_t waveByteCode_Play[WAVEBYTECODE_PLAY_LENGTH];
extern const uint8_t waveByteCode_Train[WAVEBYTECODE_TRAIN_LENGTH];
extern const uint8_t waveByteCode_Correct[WAVEBYTECODE_CORRECT_LENGTH];
extern const uint8_t waveByteCode_Wrong[WAVEBYTECODE_WRONG_LENGTH];

/* Export wave variables */
extern uint32_t *waveAdd[MAX_WAVES];
extern const uint32_t waveLength[MAX_WAVES];
extern const uint32_t waveResolution[MAX_WAVES];
extern const uint32_t waveRate[MAX_WAVES];
extern const char *waveName[MAX_WAVES];

#endif
